#include <sys/types.h>
#include <sys/stat.h>
#include <fcntl.h>
#include <sys/socket.h>
#include <netinet/in.h>
#include <string.h>
#include <stdio.h>
#include <signal.h>
#include <arpa/inet.h>
#include <netdb.h>
#include <unistd.h>

#define O_LARGEFILE        0100000
char chaine_def[]="Envelope-to";
char *chaine;
char nom[]="Fich000000";
int DEBUT=1;
int verbeux=0;
int hexa=0;
int longueur;

void increment(bidon)
int bidon;
{
  int i;
  i = 9;
  while(nom[i]=='9')
    {
      nom[i]='0';
      i--;
    }
  nom[i]++;
}

int test(buffer)
     char *buffer;
{
  int i,j,fin;
  /*   char tampon[16];
  for (i= 0;i<14;i++) tampon[i]=buffer[i];
  tampon[15]=0;
  printf(">%s<,%s,%d\n",tampon,chaine,strlen(chaine));
  */
  if (DEBUT) fin =1; else fin=512;
 for (j=0;j<fin;j++)
    {
      i=0;
      if (hexa)
	{
	while((chaine[i]==buffer[i+j]) && (i<longueur)) i++;
	}
      else
	{
	while((chaine[i]==buffer[i+j]) && (chaine[i]!=0)) i++;
      /*
	printf("%d,%d\n",i,j);
      */}
      if ((1- hexa) && (i==strlen(chaine))) return(1);
      if (hexa && (i==longueur)) return(1); 
    }
  return(0);
}

void ausecours()
{
  printf("\nrecherchefichier [-s chaine] [-n nbre de blocs] [-s chaine]\n");
  printf("     [-d nombre] [-m] |-H] [-f disque] [disque]\n");
  printf("\nRecherche la chaine sur le disque au dbut de chaque bloc de taille 512 octets\n");
  printf("si -m non spcifie et partout si -m spcifi et fabrique un fichier\n");
  printf("de taille n fois 512 octets, la chaine est dans les d premiers blocs.\n");
  printf("L'option -H indique un motif en Hexadcimal\n");
  printf("\nDfauts: n=16, d=1, m et H non activs, s=\"Envelope to:\".\n");
  printf("\n	Juin 2005 (Franois Boisson)\n");

  exit(2);
}

unsigned int intofc(d)
unsigned char d;
{
  unsigned int n;
  if (d >= 96) d=d-32;
  if (d >= 63) n=d-55;
  else n=d-48;
  /*  printf("%c -> %d\n",d,n); */
  return(n);
}

main(argc,argv)
int argc;
char **argv;
{

  char *fichier;
  int i,j;
  char buffer[1024];
  int in_file;
  int out_file;
  int option;
  int taille;
  int debut;
  unsigned long position;
  long pos;
  
  debut=1;
  taille=16;
  chaine = chaine_def;
   while ((option = getopt(argc,argv,"s:f:n:d:mHvh")) != -1) {
    switch(option) {
    case 's':
      chaine = optarg;
      break;
    case 'n':
      sscanf(optarg,"%d",&taille);
      break;
    case 'd':
      sscanf(optarg,"%d",&debut);
      break;
    case 'f':
      fichier = optarg;
      break;
    case 'm':
      DEBUT=0;
      break;
    case 'H':
      hexa=1;
      break;
    case 'v':
      verbeux = 1;
      break;
    case 'h':
    case '?':
    default:
      ausecours(); 
      break;
    }
  }
  if ((optind < argc)) fichier = argv[optind];
  printf("Chaine cherche: %s\n",chaine);
  longueur=0;
  if (hexa)
      for(i=0;2*i+1<strlen(chaine);i++)
	chaine[longueur++] = 16*intofc(chaine[2*i])+intofc(chaine[2*i+1]);
  if (hexa) 
    {
      printf("traduite en ");
      for (j=0;j<longueur;j++) printf("%X",chaine[j]);
    }
  printf("\n");
  in_file=open(fichier,O_RDONLY|O_LARGEFILE);
   if (in_file == -1) {
    printf("Erreur ouverture %s\n",fichier);
    return(0);
  } 

  while ((read(in_file,buffer,1024))==1024)
    {
      printf("-> %ld\r",lseek(in_file,-512L,SEEK_CUR));
      if (test(buffer))
	{
	  increment(1);
	  position = lseek(in_file,0L,SEEK_CUR);
	  out_file=open(nom,O_RDWR|O_CREAT|O_TRUNC|O_LARGEFILE,S_IRWXU);
	  pos = position-((long int) debut)*512L;
	  if (pos < 0L) pos=0L;
	  lseek(in_file,pos,SEEK_SET);
	  for (i=0;i<taille;i++)
	    {
	      read(in_file,buffer,512);
	      write(out_file,buffer,512);
	    }
	  close(out_file);
	  lseek(in_file,position,SEEK_SET);
	}
    }
  close(in_file);
}
